<?xml version="1.0" encoding="UTF-8"?>

<cfsSimulation xmlns="http://www.cfs++.org/simulation" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.cfs++.org/simulation http://cfs-doc.mdmt.tuwien.ac.at/xml/CFS-Simulation/CFS.xsd">

  <documentation>
   <title>Bloch mode analysis</title>
     <authors>
       <author>Fabian Wein</author>
     </authors>
     <date>2014-08-04</date>
     <keywords>
       <keyword>mechanic</keyword>
     </keywords>
     <references>
       Hussein; Reduced Bloch mode expansion for periodic media band structure calculations.pdf
     </references>
     <isVerified>yes</isVerified>
     <description>
      Does standard bloch mode analysis, not the reduced approach but the method and example is
      anyway given in the above reference.

      For a periodic cell complex eigenvalues are evaluated, following Blochs theorem ...

      Arpack is known to fail with some MKL version (breaks with an error). In that case disable
      pardiso and use OPENBLAS or NETLIB instead of MKL and disable Pardiso via USE_PARDISO=OFF.
      
      To visualize the bloch.dat file sort it with sort_bloch.py --dim 2 BlochMode2D.bloch.dat
      and create a gnuplot script via find_bloch_band_gaps.py --dim 2 BlochMode2D_sorted.bloch.dat --gnuplot
    </description>
  </documentation>

  <fileFormats>
    <input>
      <!--<mesh fileName="BlochMode2D.mesh"></mesh>-->
      <gmsh fileName="UnitCell_working.msh"></gmsh>
    </input>
    <output>
      <hdf5/>
    </output>
    <materialData file="mat.xml" format="xml" />
  </fileFormats>

  <domain geometryType="plane">
    <regionList>
      <region material="stiff" name="inner" />
      <region material="weak" name="outer" />
    </regionList>
    <nodeList>
      <nodes name="center">
        <coord x="0.5" y="0.5" />
      </nodes>
    </nodeList>
  </domain>

  <sequenceStep index="1">
    <analysis>
      <eigenFrequency>
        <isQuadratic>no</isQuadratic>
        <minVal>0</minVal>
        <maxVal>57</maxVal>
<!--        <numModes>7</numModes>
        <freqShift> 0 </freqShift>-->
        <writeModes> yes </writeModes>
        <bloch>
          <!--<ibz sample="symmetric" steps="6" />-->
          <waveVector x="1.5708" y="0"/>
        </bloch>
      </eigenFrequency>
<!--      <harmonic>
        <frequencyList>
          <freq value="1/2/pi"></freq>
        </frequencyList>
      </harmonic>-->
    </analysis>

    <pdeList>
      <mechanic subType="planeStrain">
        <regionList>
          <region name="inner"/>
          <region name="outer" />
        </regionList>

        <dampingList>
          <pml  id="myPML">
            <type> inverseDist </type>
            <dampFactor> 1 </dampFactor>
          </pml>
        </dampingList>
        
        <bcsAndLoads>
          <!-- <dirichletHom dof="x" name="down" quantity="mechDisplacement"/> 
            <dirichletHom dof="y" name="down" quantity="mechDisplacement"/ -->
          <!-- <fix name="center"> <comp dof="x"/> <comp dof="y"/> </fix> -->
          <periodic master="up" slave="down" dof="x" quantity="mechDisplacement"/>
          <periodic master="up" slave="down" dof="y" quantity="mechDisplacement"/>
          <periodic master="left" slave="right" dof="x" quantity="mechDisplacement"/>
          <periodic master="left" slave="right" dof="y" quantity="mechDisplacement"/>
        </bcsAndLoads>

        <storeResults>
          <nodeResult type="mechDisplacement">
            <allRegions />
          </nodeResult>
        </storeResults>
      </mechanic>
    </pdeList>
    <linearSystems>
      <system>
        <solutionStrategy>
          <standard>
            <!-- exportLinSys split_system="true" / -->
            <!-- matrix storage="sparseNonSym" /> -->
            <exportLinSys mass="true" stiffness="true"/>
            <matrix storage="sparseSym"/>
            <eigenSolver id="feast"/>
          </standard>
        </solutionStrategy>
        <eigenSolverList>
          <arpack>
            <logging>false</logging>
          </arpack>
          <feast id="feast">
            <logging>true</logging>
          </feast>
        </eigenSolverList>
        <solverList>
          <pardiso>
            <hermitean>yes</hermitean>
          </pardiso>
          <!--directLU/-->
        </solverList>
      </system>
    </linearSystems>

  </sequenceStep>


</cfsSimulation>


